<?php

class User {

	private $id, $username, $password, $name, $surname, $session = null;
	private static $connection;

	public function setID($id){ $this->id = $id; }
	public function setUsername($u) { $this->username = $u; }
	public function setPassword($p) { $this->password = $p; }
	public function setName($n) { $this -> name = $n; }
	public function setSurname($s) { $this -> surname = $s; }

	public function getID() { return $this -> id; }
	public function getUsername() { return $this -> username; }
	public function getPassword() { return $this -> password; }
	public function getName() { return $this -> name; }
	public function getSurname() { return $this -> surname; }
	public function getSession() { return $this -> session; }

	public function __construct($user, $password = null, $name = null, $surname = null) {
		$this -> setUsername($user);
		$this -> setPassword($password);
		$this -> setName($name);
		$this -> setSurname($surname);
		self::mysqliConnection();
	}

	public static function mysqliConnection() {
		self::$connection = new mysqli("localhost", "magic", "nrqdUz4PMKNFZ7iphnzE", "magicchall");
		if (self::$connection->connect_error) {
			die('Connect Error (' . $mysqli->connect_errno . ') '. $mysqli->connect_error);
		}
	}

	public function login() {
		$username = $this -> getUsername();
		$password = $this -> getPassword();
		if($this->setDataByUsername($username, $password)){ // if login is ok
			$this->setSession(session_id(), $username);//set session id
			$_SESSION["user"] = $username; //store username in session
			$_SESSION["userObject"] = serialize($this); //store object serialized in session
			session_write_close();//end the current session and store session data
			session_regenerate_id();
			return true; //all right
		}
		else
			throw new Exception("Wrong login or password or both");
	}

	private function setDataByUsername($user, $password) {
		$stmt = self::$connection -> prepare("SELECT id, username, password, name, surname FROM user WHERE username = ? AND password = ?");
		$stmt -> bind_param("ss", $user, $password);
		$stmt -> execute();
		$stmt -> store_result();
		if($stmt -> affected_rows === 1) {
			$stmt -> bind_result($id, $username, $password, $name, $surname);
			$stmt -> fetch();
			$this->setID($id);
			$this->setUsername($username);
			$this->setPassword($password);
			$this->setName($name);
			$this->setSurname($surname);
			return true;
		}
		else return false;
	}

	public function setSession($sess_id, $username) {
		$stmt = self::$connection->prepare("UPDATE user SET session_alive = ? WHERE username = ?");
		$stmt -> bind_param("ss", $sess_id, $username);
		$stmt -> execute();
		if($stmt -> affected_rows === 1){
			$this->session = $sess_id;
			return true;
		}
		else
			return false;
	}

	public function logout() {
	$username = $this->getUsername();
	$isLogged = $this -> isLogged($username, session_id());
		if($isLogged) {
			$stmt = self::$connection -> prepare("UPDATE user SET session_alive = NULL WHERE username = ?");
			$stmt -> bind_param("s", $this -> getUsername());
			$stmt -> execute();
			session_destroy();
			header("Location: index.php");
		}
	}

	public static function isLogged($user, $sessid) {
		self::mysqliConnection();
		$stmt = self::$connection->prepare("SELECT session_alive FROM user WHERE username = ?");
		$stmt -> bind_param("s", $user);
		$stmt -> execute();
		$stmt -> store_result();
		$stmt -> bind_result($session_alive);
		$stmt -> fetch();
		if($session_alive === $sessid && isset($_SESSION["userObject"])){
			return true;
		}
		else
			return false;
	}
	
	public function isActive(){
		$stmt = self::$connection->prepare("SELECT active FROM user WHERE id = ?");
		$id = intval($this -> getID());
		$stmt -> bind_param("d", $id);
		$stmt -> execute();
		$stmt -> store_result();
		$stmt -> bind_result($active);
		$stmt -> fetch();
		if($active)
			return true;
		else
			return false;
	}

	public function setActiveBit($bit){
		if(intval($bit) === 0 || intval($bit) === 1){
			$stmt = self::$connection->prepare("UPDATE user SET active = ? WHERE id = ?");
			$id = intval($this -> getID());
			$stmt -> bind_param("dd", $bit, $id);
			$stmt -> execute();
			if($stmt -> errno){
				throw new Exception("An error occured while set active bit");
			}
			else
				return true;
		}
	}

	public function register() {
		$stmt = self::$connection->prepare("INSERT INTO user(username, password, name, surname) VALUES(?, ?, ?, ?)");
		$username = $this -> getUsername();
		$password = $this -> getPassword();
		$name = $this -> getName();
		$surname = $this -> getSurname();
		$stmt -> bind_param("ssss", $username, $password, $name, $surname);
		$stmt -> execute();
		if($stmt -> errno === 1062)
			throw new Exception("User '".$this->getUsername()."' already exist");
		else
			return true;
	}
	
	public function __destruct(){
		self::$connection->close();
	}
}

?>
